package juliac.generated;

import java.lang.annotation.Annotation;
import java.util.ArrayList;
import org.objectweb.fractal.julia.control.lifecycle.ChainedIllegalLifeCycleException;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.scorware.tinfi.control.intent.IntentHandler;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.control.LifeCycleController;
import java.util.List;
import org.scorware.tinfi.control.intent.SCABasicIntentController;
import org.scorware.tinfi.control.intent.SCAIntentController;
import org.scorware.tinfi.TinfiComponentInterceptor;
import org.scorware.tinfi.TinfiRuntimeException;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin
 */
public class SCACompositeIntentControllerImpl implements Controller , Generated , SCABasicIntentController , SCAIntentController {
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.scorware.tinfi.control.intent.IntentHandler)
     */
    public void addFcIntentHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Add the specified intent handler on all service and reference methods of
     * the current component.
     * 
     * @param handler  the intent handler to add
     * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.scorware.tinfi.control.intent.IntentHandler)
     */
    private void addFcIntentHandler$0(IntentHandler handler) {
        List<org.scorware.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        for (TinfiComponentInterceptor tci : interceptors) {
            tci.addFcIntentHandler(handler);
        }
    }
    
    /** 
     * The {@link LifeCycleController} interface of the component to which this
     * controller object belongs.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.scorware.tinfi.control.intent.IntentHandler,java.lang.Class,java.lang.String)
     */
    public <T extends java.lang.annotation.Annotation> void addFcIntentHandler(IntentHandler handler, Class<T>  annotcl, String value) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,annotcl ,value);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$1(ic);
    }
    
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#removeFcHandler(org.scorware.tinfi.control.intent.IntentHandler)
     */
    public void removeFcHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        removeFcHandler$0(handler);
    }
    
    /** 
     * Return the list of interceptors associated with the business interfaces
     * of the current component.
     * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin#getFcInterceptors()
     */
    private List<org.scorware.tinfi.TinfiComponentInterceptor>  getFcInterceptors() {
        if ((interceptors) != null) {
            return interceptors;
        } 
        interceptors = new ArrayList<org.scorware.tinfi.TinfiComponentInterceptor> ();
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            String name = itf.getFcItfName();
            if ((name.endsWith("-controller")) || (name.equals("component"))) {
                continue;
            } 
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor)) {
                String msg = ("Interface " + name) + " was expected to delegate to an object implementing TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor tci = ((TinfiComponentInterceptor)(i));
            interceptors.add(tci);
        }
        return interceptors;
    }
    
    /** 
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#checkFcStopped()
     */
    private void checkFcStopped() throws IllegalLifeCycleException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$2(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin#interceptors
     */
    private List<org.scorware.tinfi.TinfiComponentInterceptor>  interceptors;
    
    private void addFcIntentHandler$1(IntentHandler handler) {
    }
    
    private <T extends java.lang.annotation.Annotation> void addFcIntentHandler$0(IntentHandler handler, Class<T>  annotcl, String value) {
    }
    
    private void removeFcHandler$0(IntentHandler handler) {
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCACompositeIntentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.scorware.tinfi.control.intent.LifeCycleIntentMixin)";
    }
    
}

