package juliac.generated;

import org.objectweb.fractal.julia.factory.ChainedInstantiationException;
import org.objectweb.fractal.api.Component;
import org.osoa.sca.ComponentContext;
import org.scorware.tinfi.control.component.ComponentContextDef;
import org.scorware.tinfi.control.content.scope.CompositeScopeManager;
import org.scorware.tinfi.control.content.ContentClassMetaData;
import org.objectweb.fractal.julia.Controller;
import org.scorware.tinfi.control.content.scope.ConversationScopeManager;
import org.objectweb.fractal.julia.loader.Generated;
import org.scorware.tinfi.control.content.IllegalContentClassMetaData;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.control.NameController;
import org.osoa.sca.RequestContext;
import org.scorware.tinfi.control.content.scope.RequestScopeManager;
import org.scorware.tinfi.control.content.SCAContentController;
import org.scorware.tinfi.control.property.SCAPropertyController;
import org.scorware.tinfi.control.content.scope.ScopeManager;
import java.util.Stack;
import org.scorware.tinfi.control.content.scope.StatelessScopeManager;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin
 * @see org.scorware.tinfi.control.property.UseSCAPropertyControllerMixin
 * @see org.scorware.tinfi.control.component.UseComponentContextMixin
 * @see org.scorware.tinfi.control.content.SCAContentControllerMixin
 */
public class SCAContentControllerImpl implements Controller , Generated , SCAContentController {
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.scorware.tinfi.control.property.UseSCAPropertyControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        weavablePC = ((SCAPropertyController)(ic.interfaces.get(SCAPropertyController.NAME)));
        initFcController$2(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.scorware.tinfi.control.component.UseComponentContextMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weavableCompCtx = ((ComponentContext)(ic.interfaces.get(ComponentContextDef.NAME)));
        initFcController$1(ic);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$4(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * The {@link NameController} interface of the component to which this
     * controller object belongs.
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#weaveableOptNC
     */
    public NameController weaveableOptNC;
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * The metadata for the content class associated to the component controlled
     * by the current controller.
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#ccmd
     */
    private ContentClassMetaData ccmd;
    
    /** 
     * @see org.scorware.tinfi.control.property.UseSCAPropertyControllerMixin#weavablePC
     */
    @SuppressWarnings(value = "unused")
    private SCAPropertyController weavablePC;
    
    /** 
     * @see org.scorware.tinfi.control.component.UseComponentContextMixin#weavableCompCtx
     */
    @SuppressWarnings(value = "unused")
    private ComponentContext weavableCompCtx;
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
        weaveableOptNC = ((NameController)(ic.getOptionalInterface("name-controller")));
        initFcController$3(ic);
    }
    
    /** 
     * The scope manager for the component controlled by the current controller.
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#sm
     */
    private ScopeManager sm;
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$3(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$4(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        initFcController$0(ic);
        String fcContentDesc = ((String)(ic.content));
        try {
            ccmd = ContentClassMetaData.get(fcContentDesc);
        } catch (IllegalContentClassMetaData e) {
            throw new ChainedInstantiationException(e , weaveableC , e.getMessage());
        }
        if (((ccmd.scope) == null) || (ccmd.scope.value().toUpperCase().equals("STATELESS"))) {
            sm = new StatelessScopeManager(weaveableC , weavablePC , weavableCompCtx , weaveableOptNC , ccmd);
        } else if (ccmd.scope.value().toUpperCase().equals("REQUEST")) {
            sm = new RequestScopeManager(weaveableC , weavablePC , weavableCompCtx , weaveableOptNC , ccmd);
        } else if (ccmd.scope.value().toUpperCase().equals("COMPOSITE")) {
            sm = new CompositeScopeManager(weaveableC , weavablePC , weavableCompCtx , weaveableOptNC , ccmd);
        } else if (ccmd.scope.value().toUpperCase().equals("CONVERSATION")) {
            sm = new ConversationScopeManager(weaveableC , weavablePC , weavableCompCtx , weaveableOptNC , ccmd);
        } else {
            String msg = "Unsupported scope: " + (ccmd.scope.value());
            throw new InstantiationException(msg);
        }
    }
    
    /** 
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#eagerInit()
     */
    public void eagerInit() throws InstantiationException {
        if ((ccmd.eagerinit) != null) {
            if (!((sm) instanceof CompositeScopeManager)) {
                String msg = "Eager initialization is meaningess in scopes other than COMPOSITE (scope is: " + (ccmd.scope.value());
                throw new InstantiationException(msg);
            } 
            sm.getFcContent();
        } 
    }
    
    /** 
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#getRequestContextStack()
     */
    public Stack<org.osoa.sca.RequestContext>  getRequestContextStack() {
        return sm.getRequestContextStack();
    }
    
    /** 
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#setRequestContextStack(java.util.Stack)
     */
    public void setRequestContextStack(Stack<org.osoa.sca.RequestContext>  stack) {
        sm.setRequestContextStack(stack);
    }
    
    /** 
     * Return a content instance according to the scope policy defined for this
     * component.
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#getFcContent()
     */
    public Object getFcContent() throws InstantiationException {
        return sm.getFcContent();
    }
    
    /** 
     * Notify the content controller that the specified content instance is no
     * longer needed. If relevant with the the scope policy, this gives the
     * opportunity to the controller to call the {@link Destroy} annotated
     * method on the content instance.
     * 
     * @param content  the content instance which is released
     * @param isEndMethod
     *      true if the method which releases the content instance is annotated
     *      with EndsConversation
     * @see org.scorware.tinfi.control.content.SCAContentControllerMixin#releaseFcContent(java.lang.Object,boolean)
     */
    public void releaseFcContent(Object content, boolean isEndMethod) {
        sm.releaseFcContent(content ,isEndMethod);
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$5(InitializationContext ic) throws InstantiationException {
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAContentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.julia.control.name.UseNameControllerMixin org.scorware.tinfi.control.property.UseSCAPropertyControllerMixin org.scorware.tinfi.control.component.UseComponentContextMixin org.scorware.tinfi.control.content.SCAContentControllerMixin)";
    }
    
}

