package juliac.generated;

import java.lang.annotation.Annotation;
import java.util.ArrayList;
import org.objectweb.fractal.julia.control.lifecycle.ChainedIllegalLifeCycleException;
import org.objectweb.fractal.julia.factory.ChainedInstantiationException;
import org.objectweb.fractal.juliac.runtime.ClassLoaderFcItf;
import org.objectweb.fractal.juliac.runtime.ClassLoaderItf;
import org.scorware.tinfi.control.content.ClassMetaData;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.ComponentInterface;
import org.scorware.tinfi.control.content.ContentClassMetaData;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import org.scorware.tinfi.control.content.IllegalContentClassMetaData;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.scorware.tinfi.control.intent.IntentHandler;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.juliac.runtime.Juliac;
import org.objectweb.fractal.api.control.LifeCycleController;
import java.util.List;
import java.util.Map;
import java.lang.reflect.Method;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.scorware.tinfi.control.intent.SCABasicIntentController;
import org.scorware.tinfi.control.intent.SCAIntentController;
import org.scorware.tinfi.TinfiComponentInterceptor;
import org.scorware.tinfi.TinfiRuntimeException;
import org.objectweb.fractal.api.Type;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin
 * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin
 */
public class SCAPrimitiveIntentControllerImpl implements Controller , Generated , SCABasicIntentController , SCAIntentController {
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.scorware.tinfi.control.intent.IntentHandler)
     */
    public void addFcIntentHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Add the specified intent handler on all service and reference methods of
     * the current component.
     * 
     * @param handler  the intent handler to add
     * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin#addFcIntentHandler(org.scorware.tinfi.control.intent.IntentHandler)
     */
    private void addFcIntentHandler$0(IntentHandler handler) {
        List<org.scorware.tinfi.TinfiComponentInterceptor>  interceptors = getFcInterceptors();
        for (TinfiComponentInterceptor tci : interceptors) {
            tci.addFcIntentHandler(handler);
        }
    }
    
    /** 
     * The {@link LifeCycleController} interface of the component to which this
     * controller object belongs.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#addFcIntentHandler(org.scorware.tinfi.control.intent.IntentHandler,java.lang.Class,java.lang.String)
     */
    public <T extends java.lang.annotation.Annotation> void addFcIntentHandler(IntentHandler handler, Class<T>  annotcl, String value) throws IllegalLifeCycleException {
        checkFcStopped();
        addFcIntentHandler$0(handler ,annotcl ,value);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$1(ic);
    }
    
    /** 
     * Check that the component is stopped and then call the overriden method.
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#removeFcHandler(org.scorware.tinfi.control.intent.IntentHandler)
     */
    public void removeFcHandler(IntentHandler handler) throws IllegalLifeCycleException {
        checkFcStopped();
        removeFcHandler$0(handler);
    }
    
    /** 
     * Return the list of interceptors associated with the business interfaces
     * of the current component.
     * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin#getFcInterceptors()
     */
    private List<org.scorware.tinfi.TinfiComponentInterceptor>  getFcInterceptors() {
        if ((interceptors) != null) {
            return interceptors;
        } 
        interceptors = new ArrayList<org.scorware.tinfi.TinfiComponentInterceptor> ();
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            String name = itf.getFcItfName();
            if ((name.endsWith("-controller")) || (name.equals("component"))) {
                continue;
            } 
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            if (!(i instanceof TinfiComponentInterceptor)) {
                String msg = ("Interface " + name) + " was expected to delegate to an object implementing TinfiComponentInterceptor";
                throw new TinfiRuntimeException(msg);
            } 
            TinfiComponentInterceptor tci = ((TinfiComponentInterceptor)(i));
            interceptors.add(tci);
        }
        return interceptors;
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        String fcContentDesc = ((String)(ic.content));
        try {
            cmd = ContentClassMetaData.get(fcContentDesc);
        } catch (IllegalContentClassMetaData e) {
            throw new ChainedInstantiationException(e , weaveableOptC , e.getMessage());
        }
        initFcController$2(ic);
    }
    
    /** 
     * @see org.scorware.tinfi.control.intent.LifeCycleIntentMixin#checkFcStopped()
     */
    private void checkFcStopped() throws IllegalLifeCycleException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#cmd
     */
    private ClassMetaData cmd;
    
    /** 
     * @see org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin#interceptors
     */
    private List<org.scorware.tinfi.TinfiComponentInterceptor>  interceptors;
    
    private void addFcIntentHandler$1(IntentHandler handler) {
    }
    
    /** 
     * Add the specified intent handler on all service methods of the current
     * component which satisfy the following conditions:
     * 
     * <ul>
     * <li>the implementation method in the component class is associated with
     *     an annotation of the specified class,</li>
     * <li>the annotation provides a <code>String[] value()</code> method,</li>
     * <li>one of the returned strings when calling <code>value()</code>is equal
     *     to the specified value.</li>
     * </ul>
     * 
     * @param handler  the intent handler to add
     * @param annotcl  the searched for annotation class
     * @param value    the searched for parameter value
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#addFcIntentHandler(org.scorware.tinfi.control.intent.IntentHandler,java.lang.Class,java.lang.String)
     */
    private <T extends java.lang.annotation.Annotation> void addFcIntentHandler$0(IntentHandler handler, Class<T>  annotcl, String value) {
        List<java.lang.reflect.Method>  methods = getFcMatchingMethods(annotcl ,value);
        for (Method method : methods) {
            TinfiComponentInterceptor tci = getFcInterceptor(method);
            Method m = getFcItfMethod(method);
            try {
                tci.addFcIntentHandler(handler ,m);
            } catch (NoSuchMethodException e) {
                throw new TinfiRuntimeException(e);
            }
        }
    }
    
    private <T extends java.lang.annotation.Annotation> void addFcIntentHandler$1(IntentHandler handler, Class<T>  annotcl, String value) {
    }
    
    private void removeFcHandler$0(IntentHandler handler) {
    }
    
    /** 
     * Return the list of methods implemented by the component class which
     * satisfy the following conditions:
     * 
     * <ul>
     * <li>the method is associated with an annotation of the specified class</li>
     * <li>the annotation provides a <code>String[] value()</code> method,</li>
     * <li>one of the returned strings when calling <code>value()</code>is equal
     *     to the specified value.</li>
     * </ul>
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#getFcMatchingMethods(java.lang.Class,java.lang.String)
     */
    private <T extends java.lang.annotation.Annotation> List<java.lang.reflect.Method>  getFcMatchingMethods(Class<T>  annotcl, String value) {
        List<java.lang.reflect.Method>  ret = new ArrayList<java.lang.reflect.Method> ();
        Method[] methods = cmd.getAllAnnotatedMethods(annotcl);
        for (Method method : methods) {
            T annot = method.getAnnotation(annotcl);
            if (annot == null) {
                List<java.lang.Object>  annots = cmd.getMetaData(method);
                for (Object o : annots) {
                    Class<?>  ocl = o.getClass();
                    if (annotcl.isAssignableFrom(ocl)) {
                        annot = ((T)(o));
                    } 
                }
            } 
            Class<?>  cl = annot.getClass();
            try {
                Method mvalues = cl.getMethod("value");
                String[] values = null;
                try {
                    values = ((String[])(mvalues.invoke(annot)));
                } catch (Exception e) {
                    throw new TinfiRuntimeException(e);
                }
                for (String v : values) {
                    if (v.equals(value)) {
                        ret.add(method);
                    } 
                }
            } catch (NoSuchMethodException e) {
            }
        }
        return ret;
    }
    
    /** 
     * Return the interceptor for the specified component method.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#getFcInterceptor(java.lang.reflect.Method)
     */
    private TinfiComponentInterceptor getFcInterceptor(Method method) {
        if ((mtcis) == null) {
            initFcMaps();
        } 
        if (!(mtcis.containsKey(method))) {
            String msg = "No interceptor for component method: " + (method.toString());
            throw new TinfiRuntimeException(msg);
        } 
        TinfiComponentInterceptor tci = mtcis.get(method);
        return tci;
    }
    
    /** 
     * Return the interface method for the specified component method.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#getFcItfMethod(java.lang.reflect.Method)
     */
    private Method getFcItfMethod(Method method) {
        if ((mms) == null) {
            initFcMaps();
        } 
        if (!(mms.containsKey(method))) {
            String msg = "No interface method for component method: " + (method.toString());
            throw new TinfiRuntimeException(msg);
        } 
        Method m = mms.get(method);
        return m;
    }
    
    /** 
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#mtcis
     */
    private Map<java.lang.reflect.Method, org.scorware.tinfi.TinfiComponentInterceptor>  mtcis;
    
    /** 
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#mms
     */
    private Map<java.lang.reflect.Method, java.lang.reflect.Method>  mms;
    
    /** 
     * Initialize the {@link #mtcis} and {@link #mms} maps.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#initFcMaps()
     */
    private void initFcMaps() {
        mtcis = new HashMap<java.lang.reflect.Method, org.scorware.tinfi.TinfiComponentInterceptor> ();
        mms = new HashMap<java.lang.reflect.Method, java.lang.reflect.Method> ();
        Class<?>  compcl = cmd.getSupportClass();
        Method[] methods = compcl.getMethods();
        Object[] itfs = weaveableOptC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            String name = itf.getFcItfName();
            if ((name.endsWith("-controller")) || (name.equals("component"))) {
                continue;
            } 
            Object i = ((ComponentInterface)(itf)).getFcItfImpl();
            TinfiComponentInterceptor tci = ((TinfiComponentInterceptor)(i));
            InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
            String signature = it.getFcItfSignature();
            Class<?>  business = loadFcClass(signature);
            Method[] ms = business.getMethods();
            for (Method method : methods) {
                for (Method m : ms) {
                    if (isFcSame(m ,method)) {
                        mtcis.put(method ,tci);
                        mms.put(method ,m);
                    } 
                }
            }
        }
    }
    
    /** 
     * Load, with the Tinfi classloader, the class whose name is specified.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#loadFcClass(java.lang.String)
     */
    private Class<?>  loadFcClass(String name) {
        ClassLoaderItf loader = getFcClassLoader();
        try {
            Class<?>  cl = loader.loadClass(name);
            return cl;
        } catch (ClassNotFoundException cnfe) {
            throw new TinfiRuntimeException(cnfe);
        }
    }
    
    /** 
     * Return the classloader interface provided by the Tinfi bootstrap
     * component.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#getFcClassLoader()
     */
    private ClassLoaderItf getFcClassLoader() {
        if ((loader) == null) {
            Component boot = new Juliac().newFcInstance();
            try {
                loader = ((ClassLoaderItf)(boot.getFcInterface(ClassLoaderFcItf.NAME)));
            } catch (NoSuchInterfaceException nsie) {
                throw new RuntimeException(nsie);
            }
        } 
        return loader;
    }
    
    /** 
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#loader
     */
    private ClassLoaderItf loader;
    
    /** 
     * Return true if the specified methods are the same: same name and same
     * parameters.
     * @see org.scorware.tinfi.control.intent.SCAIntentControllerMixin#isFcSame(java.lang.reflect.Method,java.lang.reflect.Method)
     */
    private boolean isFcSame(Method m1, Method m2) {
        String name1 = m1.getName();
        String name2 = m2.getName();
        if (!(name1.equals(name2))) {
            return false;
        } 
        Class<?> [] ptypes1 = m1.getParameterTypes();
        Class<?> [] ptypes2 = m2.getParameterTypes();
        if ((ptypes1.length) != (ptypes2.length)) {
            return false;
        } 
        for (int i = 0 ; i < (ptypes1.length) ; i++) {
            Class<?>  ptype1 = ptypes1[i];
            Class<?>  ptype2 = ptypes2[i];
            if (!(ptype1.equals(ptype2))) {
                return false;
            } 
        }
        return true;
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAPrimitiveIntentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.scorware.tinfi.control.intent.SCAIntentControllerMixin org.scorware.tinfi.control.intent.SCABasicIntentControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.scorware.tinfi.control.intent.LifeCycleIntentMixin)";
    }
    
}

