package juliac.generated;

import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import java.util.Map;
import org.scorware.tinfi.control.property.SCAPropertyController;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.scorware.tinfi.control.property.SCAPropertyControllerMixin
 */
public class SCAPropertyControllerImpl implements Controller , Generated , SCAPropertyController {
    /** 
     * @see org.scorware.tinfi.control.property.SCAPropertyControllerMixin#properties
     */
    private Map<java.lang.String, java.lang.Object>  properties = new HashMap<java.lang.String, java.lang.Object> ();
    
    /** 
     * Set the value for the specified property name. If the property has
     * already been set, the old value is lost, and the new value is recorded.
     * 
     * @param name   the property name
     * @param value  the property value
     * @see org.scorware.tinfi.control.property.SCAPropertyControllerMixin#set(java.lang.String,java.lang.Object)
     */
    public void set(String name, Object value) {
        properties.put(name ,value);
    }
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Return the value for the specified property name. Return null if the
     * property has not been set.
     * 
     * @param name  the property name
     * @return      the property value
     * @see org.scorware.tinfi.control.property.SCAPropertyControllerMixin#get(java.lang.String)
     */
    public Object get(String name) {
        return properties.get(name);
    }
    
    /** 
     * Return true if the specified property name has been set.
     * 
     * @param name  the property name
     * @return      true if the property has been set, false otherwise
     * @see org.scorware.tinfi.control.property.SCAPropertyControllerMixin#containsKey(java.lang.String)
     */
    public boolean containsKey(String name) {
        return properties.containsKey(name);
    }
    
    /** 
     * Return a map of all the properties which have been set so far.
     * 
     * @return  a map of all the properties which have been set so far
     * @see org.scorware.tinfi.control.property.SCAPropertyControllerMixin#getAll()
     */
    public Map<java.lang.String, java.lang.Object>  getAll() {
        return properties;
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAPropertyControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.scorware.tinfi.control.property.SCAPropertyControllerMixin)";
    }
    
}

